//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include "entities.h"
#include "enemigo.h"
#include "enemigo2.h"
#include "mapa.h"
#include "player.h"

#define LIMITE_DERECHO ANCHO_PANTALLA - G_ENEMIGO_00_W
#define LIMITE_ABAJO LARGO_PANTALLA - G_ENEMIGO_00_H

u8 time = 50;
u8 num;
TUnidad enemigos[3];
u8 enemigosAhora = 0;
extern u8 puntos;
extern u8 cPu;
extern u8 morts;

u8 getVivoE(u8 e){ return enemigos[e].vivo; }

void inicializarMovimiento(u32 seed) {
	u16 plusSeed = (u16) seed;
	cpct_setSeed_xsp40_u8 (plusSeed, seed);
	cpct_setSeed_glfsr16 (plusSeed);
}

u8 mixedRandomGenerator() {
   return cpct_getRandom_xsp40_u8();
}

u16 tiempoRandom() {
   return cpct_getRandom_glfsr16_u8();
}

void drawEnemy(u8 e){
  u8* pvmen = cpct_getScreenPtr(CPCT_VMEM_START, enemigos[e].x, enemigos[e].y);
  cpct_drawSpriteMaskedAlignedTable (enemigos[e].sprite, pvmen, G_ENEMIGO_00_W, G_ENEMIGO_00_H, g_tablatrans);
}

void deleteEnemy(u8 e){
  cpct_etm_drawTileBox2x4 (enemigos[e].px/2, (enemigos[e].py - ORIGEN_MAPA_Y)/4, 4, 5, 40, ORIGEN_MAPA, getMapa());
}

void reDrawEnemy(u8 e){
  deleteEnemy(e);
  enemigos[e].px=enemigos[e].x;
  enemigos[e].py=enemigos[e].y;
  drawEnemy(e);
}

void initEnemy(){
  enemigos[0].x = enemigos[0].px = 4;
  enemigos[0].y = enemigos[0].py = 24;
  enemigos[0].mover = NO;
  enemigos[0].sprite = g_enemigo_00;
  enemigos[0].vivo = 0;
  enemigos[0].tipo = 0;
  enemigos[1].vivo = 1;
  enemigos[2].vivo = 1;
  enemigosAhora++;
  drawEnemy(0);
}

void fabricaDeEnemigos(){
	u8 c = 0;
	u8 selector = mixedRandomGenerator() % 2;
	for(c = 0; c < 3 && getVivoE(c) == 1; c++){
		enemigos[c].mover = NO;
		enemigos[c].vivo = 0;
		enemigos[c].y = enemigos[c].py = 24;
		if(selector == 0 ){
			enemigos[c].sprite = g_enemigo_00;
			enemigos[c].tipo = 0;
			if(c == 0){
				enemigos[c].x = enemigos[c].px = 4;
			}
			else if(c == 1) {
				enemigos[c].x = enemigos[c].px = 40;
			}
			else if(c == 2){
				enemigos[c].x = enemigos[c].px = 70;
			}
			selector = 1;
		}
		else if(selector == 1 ){
			enemigos[c].sprite = g_enemigo2_00;
			enemigos[c].tipo = 1;
			if(c == 0){
				enemigos[c].x = enemigos[c].px = 4;
			}
			else if(c == 1) {
				enemigos[c].x = enemigos[c].px = 40;
			}
			else if(c == 2){
				enemigos[c].x = enemigos[c].px = 70;
			}
			selector = 0;
		}
		enemigosAhora++;
		drawEnemy(c);
	}
}

u8 comprobarColisionE(u8 e, u8 c, i8 x, i8 y){
	switch (e) {
		case 0:
			if(enemigos[e].x+7+(x) < enemigos[c].x){
		    return 1;
		  }
		  if(enemigos[e].y+14+(y) < enemigos[c].y){
		    return 1;
		  }
		  if(enemigos[e].x+(x) > enemigos[c].x+7){
		    return 1;
		  }
		  if(enemigos[e].y+(y) > enemigos[c].y+14){
		    return 1;
		  }
			break;
		case 1:
			if(enemigos[e].x+7+(x) < enemigos[c].x){
				return 1;
			}
			if(enemigos[e].y+14+(y) < enemigos[c].y){
				return 1;
			}
			if(enemigos[e].x+(x) > enemigos[c].x+7){
				return 1;
			}
			if(enemigos[e].y+(y) > enemigos[c].y+14){
				return 1;
			}
			break;
		case 2:
			if(enemigos[e].x+7+(x) < enemigos[c].x){
				return 1;
			}
			if(enemigos[e].y+14+(y) < enemigos[c].y){
				return 1;
			}
			if(enemigos[e].x+(x) > enemigos[c].x+7){
				return 1;
			}
			if(enemigos[e].y+(y) > enemigos[c].y+14){
				return 1;
			}
			break;
	}
  return 0;
}

u8 movLE(u8 e, u8 c){
	switch (e) {
		case 0:
			c = comprobarColisionE(e,1,1,0);
			if(c == 1){
				c = comprobarColisionE(e,2,1,0);
			}
			break;
		case 1:
			c = comprobarColisionE(e,0,1,0);
			if(c == 1){
				c = comprobarColisionE(e,2,1,0);
			}
			break;
		case 2:
			c = comprobarColisionE(e,1,1,0);
			if(c == 1){
				c = comprobarColisionE(e,0,1,0);
			}
			break;
	}
	if(enemigos[e].x > 0 && colision(0,enemigos[e].x,enemigos[e].y,7,14) == 0 && c == 1){
		--enemigos[e].x;
		enemigos[e].mover = SI;
		if(enemigos[e].tipo == 0){
			enemigos[e].sprite = g_enemigo_06;
		}
		else if(enemigos[e].tipo == 1){
			enemigos[e].sprite = g_enemigo2_06;
		}
		if(comprobarMuerte(enemigos[e].x,enemigos[e].y,getXplayer(),getYplayer(),7,14) == 0){
			matarJ();
		}
	}
	else{
		return 3;
	}
	return 0;
}
u8 movRI(u8 e, u8 c){
	switch (e) {
		case 0:
			c = comprobarColisionE(e,1,1,0);
			if(c == 1){
				c = comprobarColisionE(e,2,1,0);
			}
			break;
		case 1:
			c = comprobarColisionE(e,0,1,0);
			if(c == 1){
				c = comprobarColisionE(e,2,1,0);
			}
			break;
		case 2:
			c = comprobarColisionE(e,1,1,0);
			if(c == 1){
				c = comprobarColisionE(e,0,1,0);
			}
			break;
	}
	if(enemigos[e].x < LIMITE_DERECHO && colision(2,enemigos[e].x,enemigos[e].y,7,14) == 0 && c == 1){
		++enemigos[e].x;
		enemigos[e].mover = SI;
		if(enemigos[e].tipo == 0){
			enemigos[e].sprite = g_enemigo_00;
		}
		else if(enemigos[e].tipo == 1){
			enemigos[e].sprite = g_enemigo2_00;
		}
		if(comprobarMuerte(enemigos[e].x,enemigos[e].y,getXplayer(),getYplayer(),7,14) == 0){
			matarJ();
		}
	}
	else{
		return 5;
	}
	return 0;
}
u8 movUP(u8 e, u8 c){
	switch (e) {
		case 0:
			c = comprobarColisionE(e,1,0,-2);
			if(c == 1){
				c = comprobarColisionE(e,2,0,-2);
			}
			break;
		case 1:
			c = comprobarColisionE(e,0,0,-2);
			if(c == 1){
				c = comprobarColisionE(e,2,0,-2);
			}
			break;
		case 2:
			c = comprobarColisionE(e,1,0,-2);
			if(c == 1){
				c = comprobarColisionE(e,0,0,-2);
			}
			break;
	}
	if(enemigos[e].y > 20 && colision(1,enemigos[e].x,enemigos[e].y,7,14) == 0 && c == 1){
		enemigos[e].y = enemigos[e].y - 2;
		enemigos[e].mover = SI;
		if(enemigos[e].tipo == 0){
			enemigos[e].sprite = g_enemigo_03;
		}
		else if(enemigos[e].tipo == 1){
			enemigos[e].sprite = g_enemigo2_03;
		}
		if(comprobarMuerte(enemigos[e].x,enemigos[e].y,getXplayer(),getYplayer(),7,14) == 0){
			matarJ();
		}
	}
	else{
		return 4;
	}
	return 0;
}
u8 movDO(u8 e, u8 c){
	switch (e) {
		case 0:
			c = comprobarColisionE(e,1,0,2);
			if(c == 1){
				c = comprobarColisionE(e,2,0,2);
			}
			break;
		case 1:
			c = comprobarColisionE(e,0,0,2);
			if(c == 1){
				c = comprobarColisionE(e,2,0,2);
			}
			break;
		case 2:
			c = comprobarColisionE(e,1,0,2);
			if(c == 1){
				c = comprobarColisionE(e,0,0,2);
			}
			break;
	}
	if(enemigos[e].y < LIMITE_ABAJO && colision(3,enemigos[e].x,enemigos[e].y,7,14) == 0 && c == 1){
		enemigos[e].y = enemigos[e].y + 2;
		enemigos[e].mover = SI;
		if(enemigos[e].tipo == 0){
			enemigos[e].sprite = g_enemigo_09;
		}
		else if(enemigos[e].tipo == 1){
			enemigos[e].sprite = g_enemigo2_09;
		}
		if(comprobarMuerte(enemigos[e].x,enemigos[e].y,getXplayer(),getYplayer(),7,14) == 0){
			matarJ();
		}
	}
	else{
		return 2;
	}
	return 0;
}
// 0 = up, 1 = right, 2 = down, 3 = left
//hacer que hasta X tiempo no vuelva a pedir otro numero
void actionMove(u8 e){
	u8 col = 0;
	if(time == 50){
		num = (mixedRandomGenerator() + (tiempoRandom() % 100)) % 32;
		num = ((puntos+1)*num + (tiempoRandom() % 100 + mixedRandomGenerator())) % 32;
		num = num + enemigos[e].tipo + 1;
		if(num >= 32)
			num = num % 32;
		time = 0;
	}
	else{
		++time;
	}
	if(num == 0 || num == 4 || num == 8 || num == 12 || num == 16 || num == 20 || num == 24 || num == 28 || num == 32){ // 0 = up
		col = movUP(e, col);
	}
	if(num == 1 || num == 5 || num == 9 || num == 13 || num == 17 || num == 21 || num == 25 || num == 29){ //1 = right
		col = movRI(e, col);
	}
	if((num == 2 || num == 6 || num == 10 || num == 14 || num == 18 || num == 22 || num == 26 || num == 30) || col == 4){ //2 = down
		col = movDO(e, col);
	}
	if((num == 3 || num == 7 || num == 11 || num == 15 || num == 19 || num == 23 || num == 27 || num == 31) || col == 5){ //3 = left
		col = movLE(e, col);
	}
	if((num == 0 || num == 4 || num == 8 || num == 12 || num == 16 || num == 20 || num == 24 || num == 28 || num == 32) || col == 2){ // 0 = up
		col = movUP(e, col);
	}
	if((num == 1 || num == 5 || num == 9 || num == 13 || num == 17 || num == 21 || num == 25 || num == 29) || col == 3){ //1 = right
		col = movRI(e, col);
	}
}
u8 enemigosNow(){ return enemigosAhora; }
u8 getMoverEnemigo(u8 e){ return enemigos[e].mover; }
void setMoverEnemigo(u8 n, u8 e){ enemigos[e].mover = n; }
u8 getXenemy(u8 e){ return enemigos[e].x; }
u8 getYenemy(u8 e){ return enemigos[e].y; }
void matarE(u8 e){
	if(enemigos[e].tipo == 0){
		puntos += 1;
	}
	else{
		puntos += 2;
	}
  enemigos[e].vivo = 1;
  deleteEnemy(e);
  cPu = 0;
  --enemigosAhora;
	++morts;
}
void setEnemigos(){
	enemigosAhora = 0;
	enemigos[0].vivo = 1;
	enemigos[1].vivo = 1;
	enemigos[2].vivo = 1;
}
