#include <cpctelera.h>
#include "mapa.h"

cpctm_createTransparentMaskTable (g_tablatrans, 0x0100, M0, 0);

//0 -> izquierda, 1 -> arriba, 2 -> derecha, 3 -> abajo
//dir -> direccion movimiento, x -> pos x del sprite, y -> pos y del sprite, w -> amplitud sprite, h -> altura Sprite
u8 colision(u8 dir,u8 x, u8 y, u8 w, u8 h){
  u8* pos1;
  u8* pos2;
  u8* pos3;
  switch (dir) {
    case 0:
      pos1 = getMapa()+(y-20+1)/4*40+(x-1)/2;
      pos2 = getMapa()+(y-20+(h/2))/4*40+(x-1)/2;
      pos3 = getMapa()+(y-20+h-1)/4*40+(x-1)/2;
      if((*pos1==2)&&(*pos2==2)&&(*pos3==2)){
        return 0;
      }
      else{
        return 1;
      }
    case 1:
      pos1 = getMapa()+(y-20-1)/4*40+(x+1)/2;
      pos2 = getMapa()+(y-20-1)/4*40+(x+w/2)/2;
      pos3 = getMapa()+(y-20-1)/4*40+(x+w-1)/2;
      if((*pos1==2)&&(*pos2==2)&&(*pos3==2)){
        return 0;
      }
      else{
        return 1;
      }
    case 2:
      pos1 = getMapa()+(y-20+1)/4*40+(x+w+1)/2;
      pos2 = getMapa()+(y-20+(h/2))/4*40+(x+w+1)/2;
      pos3 = getMapa()+(y-20+h-1)/4*40+(x+w+1)/2;
      if((*pos1==2)&&(*pos2==2)&&(*pos3==2)){
        return 0;
      }
      else{
        return 1;
      }
    case 3:
      pos1 = getMapa()+(y-20+h+1)/4*40+(x+1)/2;
      pos2 = getMapa()+(y-20+h+1)/4*40+(x+(w/2))/2;
      pos3 = getMapa()+(y-20+h+1)/4*40+(x+w-1)/2;
      if((*pos1==2)&&(*pos2==2)&&(*pos3==2)){
        return 0;
      }
      else{
        return 1;
      }
  }
  return 1;
}

void modificarMapa(u8 dir,u8 x, u8 y, u8 w, u8 h){
  u8* pos1;
  u8* pos2;
  u8* pos3;
  switch (dir) {
    case 0:
      pos1 = getMapa()+(y-20+1)/4*40+(x-1)/2;
      pos2 = getMapa()+(y-20+(h/2))/4*40+(x-1)/2;
      pos3 = getMapa()+(y-20+h-1)/4*40+(x-1)/2;
      if((*pos1==4)||(*pos1==5)||(*pos1==10)||(*pos1==11)){
        *(getMapa()+(y-20+1)/4*40+(x-1)/2) = 2;
      }
      else if((*pos2==4)||(*pos2==5)||(*pos2==10)||(*pos2==11)){
        *(getMapa()+(y-20+(h/2))/4*40+(x-1)/2) = 2;
      }
      else if((*pos3==4)||(*pos3==5)||(*pos3==10)||(*pos3==11)){
        *(getMapa()+(y-20+h-1)/4*40+(x-1)/2) = 2;
      }
    case 1:
      pos1 = getMapa()+(y-20-1)/4*40+(x+1)/2;
      pos2 = getMapa()+(y-20-1)/4*40+(x+w/2)/2;
      pos3 = getMapa()+(y-20-1)/4*40+(x+w-1)/2;
      if((*pos1==4)||(*pos1==5)||(*pos1==10)||(*pos1==11)){
        *(getMapa()+(y-20-1)/4*40+(x+1)/2) = 2;
      }
      else if((*pos2==4)||(*pos2==5)||(*pos2==10)||(*pos2==11)){
        *(getMapa()+(y-20-1)/4*40+(x+w/2)/2) = 2;
      }
      else if((*pos3==4)||(*pos3==5)||(*pos3==10)||(*pos3==11)){
        *(getMapa()+(y-20-1)/4*40+(x+w-1)/2) = 2;
      }
    case 2:
      pos1 = getMapa()+(y-20+1)/4*40+(x+w+1)/2;
      pos2 = getMapa()+(y-20+(h/2))/4*40+(x+w+1)/2;
      pos3 = getMapa()+(y-20+h-1)/4*40+(x+w+1)/2;
      if((*pos1==4)||(*pos1==5)||(*pos1==10)||(*pos1==11)){
        *(getMapa()+(y-20+1)/4*40+(x+w+1)/2) = 2;
      }
      else if((*pos2==4)||(*pos2==5)||(*pos2==10)||(*pos2==11)){
        *(getMapa()+(y-20+(h/2))/4*40+(x+w+1)/2) = 2;
      }
      else if((*pos3==4)||(*pos3==5)||(*pos3==10)||(*pos3==11)){
        *(getMapa()+(y-20+h-1)/4*40+(x+w+1)/2) = 2;
      }
    case 3:
      pos1 = getMapa()+(y-20+h+1)/4*40+(x+1)/2;
      pos2 = getMapa()+(y-20+h+1)/4*40+(x+(w/2))/2;
      pos3 = getMapa()+(y-20+h+1)/4*40+(x+w-1)/2;
      if((*pos1==4)||(*pos1==5)||(*pos1==10)||(*pos1==11)){
        *(getMapa()+(y-20+h+1)/4*40+(x+1)/2) = 2;
      }
      else if((*pos2==4)||(*pos2==5)||(*pos2==10)||(*pos2==11)){
        *(getMapa()+(y-20+h+1)/4*40+(x+(w/2))/2) = 2;
      }
      else if((*pos3==4)||(*pos3==5)||(*pos3==10)||(*pos3==11)){
        *(getMapa()+(y-20+h+1)/4*40+(x+w-1)/2) = 2;
      }
  }
}

u8 comprobarMuerte(u8 ax, u8 ay, u8 bx, u8 by, u8 aw, u8 ah){
  if(ax+aw < bx){
    return 1;
  }
  if(ay+ah < by){
    return 1;
  }
  if(ax > bx+7){
    return 1;
  }
  if(ay > by+14){
    return 1;
  }
  return 0;
}
