//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include <stdio.h>
#include <string.h>
#include "player.h"
#include "enemy.h"
#include "mapa.h"
#include "portada.h"
#include "gameover.h"
#include "gamevictory.h"

u8 str[12];
u8 caca[12];

u8 lastKey, lastBullet;
u8 puntos = 0;
u8 state = 0;
u8 control = 0;
u8 ronda = 0;
u8 cPu = 0;
u8 gO = 0;
u8 gW = 0;
u8 gR = 0;
u8 tempo = 0;
u8 morts = 0;

void setState(u8 newState){
	state = newState;
	cpct_clearScreen(0xC000);
}

void canviarRonda(){
	++ronda;
	sprintf(str, "Ronda %u", ronda);
	cpct_drawStringM0(str, cpctm_screenPtr(CPCT_VMEM_START, 30, 90), 9, 0);
	cpct_drawStringM0("Press SPACE...", cpctm_screenPtr(CPCT_VMEM_START, 25, 170), 13, 0);
	gR = 1;
}

void gameStart(){
	cpct_drawSprite(g_portada_0, cpctm_screenPtr(CPCT_VMEM_START, 0, 0), G_PORTADA_0_W, G_PORTADA_0_H);
	cpct_drawSprite(g_portada_1, cpctm_screenPtr(CPCT_VMEM_START, 40, 0), G_PORTADA_1_W, G_PORTADA_1_H);
	if(tempo%5 == 0 || tempo%3 == 0){
    cpct_drawStringM0("Press SPACE for play", cpctm_screenPtr(CPCT_VMEM_START, 0, 100), 3, 0);
  }
  else{
    cpct_drawStringM0("Press SPACE for play", cpctm_screenPtr(CPCT_VMEM_START, 0, 100), 0, 9);
  }
	cpct_drawStringM0("David Segarra", cpctm_screenPtr(CPCT_VMEM_START, 0, 150), 9, 0);
	cpct_drawStringM0("Rodriguez", cpctm_screenPtr(CPCT_VMEM_START, 0, 160), 9, 0);
	cpct_drawStringM0("Jaume Lloret", cpctm_screenPtr(CPCT_VMEM_START, 0, 170), 4, 0);
	cpct_drawStringM0("Enriquez", cpctm_screenPtr(CPCT_VMEM_START, 0, 180), 4, 0);
	++tempo;
	cpct_scanKeyboard_if();
	if(cpct_isAnyKeyPressed()){
		if(cpct_isKeyPressed(Key_Space) || cpct_isKeyPressed(Joy0_Fire1)){
			setState(1);
		}
	}
}

void gameVictory(){
	cpct_drawSprite(g_f11_0, cpctm_screenPtr(CPCT_VMEM_START, 6+0, 20), G_F11_0_W, G_F11_0_H);
	cpct_drawSprite(g_f11_1, cpctm_screenPtr(CPCT_VMEM_START, 6+G_F11_0_W, 20), G_F11_1_W, G_F11_1_H);
	cpct_drawSprite(g_f12, cpctm_screenPtr(CPCT_VMEM_START, 6+7, 14), G_F12_W, G_F12_H);
	cpct_drawSprite(g_f13, cpctm_screenPtr(CPCT_VMEM_START, 6+26, 0), G_F13_W, G_F13_H);
	cpct_drawSprite(g_f14, cpctm_screenPtr(CPCT_VMEM_START, 6+44, 14), G_F14_W, G_F14_H);
	cpct_drawSprite(g_f15, cpctm_screenPtr(CPCT_VMEM_START, 6+6, 24), G_F15_W, G_F15_H);
	cpct_drawSprite(g_f16, cpctm_screenPtr(CPCT_VMEM_START, 6+47, 24), G_F16_W, G_F16_H);
	cpct_drawSprite(g_f17, cpctm_screenPtr(CPCT_VMEM_START, 6+14, 44), G_F17_W, G_F17_H);
	cpct_drawSprite(g_f18, cpctm_screenPtr(CPCT_VMEM_START, 6+38, 44), G_F18_W, G_F18_H);
	cpct_drawSprite(g_f9, cpctm_screenPtr(CPCT_VMEM_START, 27, 77), G_F9_W, G_F9_H);
	sprintf(str, "%u", puntos);
	cpct_drawStringM0(str, cpctm_screenPtr(CPCT_VMEM_START, 54, 78), 9, 0);
	cpct_drawStringM0("Press SPACE...", cpctm_screenPtr(CPCT_VMEM_START, 25, 170), 13, 0);
	gW = 1;
}

void gameOver(){
	cpct_drawSprite(g_f1, cpctm_screenPtr(CPCT_VMEM_START, 9, 110), G_F1_W, G_F1_H);
	cpct_drawSprite(g_f2, cpctm_screenPtr(CPCT_VMEM_START, 0, 70), G_F2_W, G_F2_H);
	cpct_drawSprite(g_f3, cpctm_screenPtr(CPCT_VMEM_START, 20, 20), G_F3_W, G_F3_H);
	cpct_drawSprite(g_f4, cpctm_screenPtr(CPCT_VMEM_START, 30, 20), G_F4_W, G_F4_H);
	cpct_drawSprite(g_f5, cpctm_screenPtr(CPCT_VMEM_START, 30, 34), G_F5_W, G_F5_H);
	cpct_drawSprite(g_f6, cpctm_screenPtr(CPCT_VMEM_START, 66, 20), G_F6_W, G_F6_H);
	cpct_drawSprite(g_f7, cpctm_screenPtr(CPCT_VMEM_START, 75, 60), G_F7_W, G_F7_H);
	cpct_drawSprite(g_f8, cpctm_screenPtr(CPCT_VMEM_START, 36, 130), G_F8_W, G_F8_H);
	cpct_drawSprite(g_f9, cpctm_screenPtr(CPCT_VMEM_START, 27, 77), G_F9_W, G_F9_H);
	sprintf(str, "%u", puntos);
	cpct_drawStringM0(str, cpctm_screenPtr(CPCT_VMEM_START, 54, 78), 9, 0);
	cpct_drawStringM0("Press SPACE...", cpctm_screenPtr(CPCT_VMEM_START, 25, 170), 13, 0);
	gO = 1;
}

void comprobarTeclado(){
	cpct_scanKeyboard_if();
	if(cpct_isAnyKeyPressed()){
		if(cpct_isKeyPressed(Key_A) || cpct_isKeyPressed(Joy0_Left)){
			if((cpct_isKeyPressed(Key_J) || cpct_isKeyPressed(Joy0_Fire1)) && getVecesPlayer() == 0){
				shootLeft();
				lastBullet = 3;
			}
			moverIzq();
			lastKey = 3;
		}
		else if(cpct_isKeyPressed(Key_D) || cpct_isKeyPressed(Joy0_Right)){
			if((cpct_isKeyPressed(Key_J) || cpct_isKeyPressed(Joy0_Fire1)) && getVecesPlayer() == 0){
				shootRight();
				lastBullet = 1;
			}
			moverDerch();
			lastKey = 1;
		}
		else if(cpct_isKeyPressed(Key_W) || cpct_isKeyPressed(Joy0_Up)){
			if((cpct_isKeyPressed(Key_J) || cpct_isKeyPressed(Joy0_Fire1)) && getVecesPlayer() == 0){
				shootUp();
				lastBullet = 0;
			}
			moverArriba();
			lastKey = 0;
		}
		else if(cpct_isKeyPressed(Key_S) || cpct_isKeyPressed(Joy0_Down)){
			if((cpct_isKeyPressed(Key_J) || cpct_isKeyPressed(Joy0_Fire1)) && getVecesPlayer() == 0){
				shootDown();
				lastBullet = 2;
			}
			moverAbajo();
			lastKey = 2;
		}
		else if((cpct_isKeyPressed(Key_J) || cpct_isKeyPressed(Joy0_Fire1)) && getVecesPlayer() == 0){
			// w = 0; D = 1; S = 2; A = 3
			switch(lastKey){
				case 0:
					shootUp();
					lastBullet = 0;
					break;
				case 1:
					shootRight();
					lastBullet = 1;
					break;
				case 2:
					shootDown();
					lastBullet = 2;
					break;
				case 3:
					shootLeft();
					lastBullet = 3;
					break;
			}
		}
	}//any key pressed
}

void game() {
	u8 j = 0;

	// Loop forever
	while (1){
		switch(state){
			case 0:
				gameStart();
				break;
			case 1:
				if(control == 0){
					cpct_drawStringM0("SPACE", cpctm_screenPtr(CPCT_VMEM_START, 2, 0), 3, 0);
					cpct_drawStringM0("WAR", cpctm_screenPtr(CPCT_VMEM_START, 22, 2), 12, 0);
					inicializarMapa(ronda);
					startGame();
					if(tempo == 0){
						++tempo;
					}
					inicializarMovimiento(tempo);
					initEnemy();
					control = 1;
				}
				if(cPu == 0){
					sprintf(str, "Score: %u", puntos);
					cpct_drawStringM0(str, cpctm_screenPtr(CPCT_VMEM_START, 36, 9), 9, 0);
					sprintf(caca, "Enemy: %u", morts);
					cpct_drawStringM0(caca, cpctm_screenPtr(CPCT_VMEM_START, 36, 0), 9, 0);
					cPu = 1;
				}
				if(morts <= 20 && enemigosNow() < 3){
					fabricaDeEnemigos();
				}
				comprobarTeclado();
				cpct_waitVSYNC();//se usa para quitar el parpadeo y ajustar el movimiento para que sea mas fluido
				for(j = 0; j < 3 && getVivoE(j) == 0; j++){
					actionMove(j);
					if(getMoverEnemigo(j) == 1){
						reDrawEnemy(j);
						setMoverEnemigo(0,j);
					}
				}
				cpct_waitVSYNC();//se usa para quitar el parpadeo y ajustar el movimiento para que sea mas fluido
				
				if(getMoverPlayer() == 1){
					reDrawTank();
					setMoverPlayer(0);
				}
				if(getVecesPlayer() == 1){
					switch(lastBullet){
						case 0:
							shootUp();
							break;
						case 1:
							shootRight();
							break;
						case 2:
							shootDown();
							break;
						case 3:
							shootLeft();
							break;
						default:
							if(getVecesPlayer() == 0){
								lastBullet = lastKey;
							}
							break;
					}
				}
				if(getVivo() == 1){
					setBala0();
					setEnemigos();
					morts = 0;
					control = 0;
					cPu = 0;
					ronda = 0;
					setState(2);
				}
				if(morts == 20){
					setBala0();
					setEnemigos();
					control = 0;
					cPu = 0;
					morts = 0;
					if(ronda == 2){
						ronda = 0;
						setState(3);
					}
					else{
						setState(4);
					}
				}
				break;
			case 2:
				if(gO == 0){
					gameOver();
				}
				cpct_scanKeyboard_if();
				if(cpct_isAnyKeyPressed()){
					if(cpct_isKeyPressed(Key_Space) || cpct_isKeyPressed(Joy0_Fire1)){
						gO = 0;
						puntos = 0;
						setState(0);
					}
				}
				break;
			case 3:
				if(gW == 0){
					gameVictory();
				}
				cpct_scanKeyboard_if();
				if(cpct_isAnyKeyPressed()){
					if(cpct_isKeyPressed(Key_Space) || cpct_isKeyPressed(Joy0_Fire1)){
						gW = 0;
						puntos = 0;
						setState(0);
					}
				}
				break;
			case 4:
				if(gR == 0){
					canviarRonda();
				}
				cpct_scanKeyboard_if();
				if(cpct_isAnyKeyPressed()){
					if(cpct_isKeyPressed(Key_Space) || cpct_isKeyPressed(Joy0_Fire1)){
						gR = 0;
						setState(1);
					}
				}
				break;
		}
	}
}
