//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 Dardalorth / Fremos / Carlio
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//// GAME MODULE
////   Controls all the high-level logic that implements the game
////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

#ifndef _PLAYER_H_
#define _PLAYER_H_

#include <types.h>

//
// Forward declarated TCharacter struct (as we use a pointer in updateUser,
//   and compiler must now its existance, but not its definition details).
//


//
// Functions defined in the game module
//void

void moverIzq();
void moverDerch();
void moverArriba();
void moverAbajo();

void drawTank();
void deleteTank();
void startGame();
void reDrawTank();

void shootUp();
void shootRight();
void shootDown();
void shootLeft();

void drawBullet();
void reDrawBullet();
void deleteBullet();
void initBullet();
void matarJ();
void setBala0();

//get
u8 getMoverPlayer();
u8 getVecesPlayer();
u8 getVivo();

u8 getXplayer();
u8 getYplayer();

//sets
void setMoverPlayer(u8 n);

#endif
